#!/usr/bin/perl

require "vars.pl";

$LoginNotRequired = 1;
require "event/login.pl";

#require "gr/datetime.pl";

$curdir = `/bin/pwd`;
chomp $curdir;
chdir "$GameroomDir";
require "cgi.pl";
require "html.pl";
#require "datetime.pl";
#require "cookie.pl";
require "data.pl";
# need this to initilize the db before changing directory
%r = &DataGetSessionRec(1);
#
#%c = &CookieRead();


if ($c{sid} ne ""){
  %r = &DataGetSessionRec($c{sid});
}

chdir "$curdir";
chdir "event";

use event::Tourn;

CgiPrintHeader();

############################
# Set this to the event id; such as 2010wc
############################
#$in{e} = "test6";
#$in{e} = "2010wc";
$in{e} = $eventID; # eventID is set in vars.pl

$e = ProcessInputChange($in{e}, 'lower', 'alphaNum');

if ($e eq ''){
  HtmlErrorPage("Need Event", "The event id was not given.");
  exit;
}

if (! Tourn->exists($e)){
  HtmlErrorPage("Need Event", "The event [$e] was not found.");
  exit;
}

$ev = Tourn->load($e);
if (! $ev){
  HtmlErrorPage("Not Read", "Event [$e] could not be read.\n");
  exit;
}

$now = time;

%e = $ev->getEvent();
@games = $ev->getGames();
$round = $ev->getRound();
$status = $ev->getRoundStatus($round);
$eventFullName = $ev->getEventFullName();
$eventName = $ev->getEventName();






# look for files that begin with r followed by a number
#   like r1pairs, r1sched, r1results

$gmt = "GMT";
if ($r{id} ne ""){ $gmt = "YLT"; }

#for($r=1;$r<10;$r++){
for($rn=$round; $rn>=1; $rn--){
#  $fn = "";
  $roundName = "";
#  if (-e "$RoundsDir/r${r}pairs"){ $fn = "r${r}pairs"; }
#  if (-e "$RoundsDir/r${r}sched"){ $fn = "r${r}sched"; }
#  if (-e "$RoundsDir/r${r}results"){ $fn = "r${r}results"; }
#  if ($fn eq ""){ last; }
  $gameRows = "";
  $clickOnBoard = "";
  $gameTimes = "";

  @p = $ev->getPlayersByRound($rn);
  $pl = '';
  foreach $p (@p){
    $rating{$p->{u}} = $p->{r};
    $orderby = $p->{r};
    if ($p->{orderby} ne ''){
      $orderby = $p->{orderby};
    }
    $pl .= "$p->{u} $orderby<br>\n";
  }


#  open(FH, "<$RoundsDir/$fn");
#  foreach $l (<FH>){

  @g = $ev->getGamesByRound($rn);


# Before looping through the games get the record for the games from the database
  %g = DataGetTempGameRec("postal=1 and eventid like '$eventName R1%'");
  while($g{id}){
    my(%gr);
    %gr = %g;
    $gr{done} = 0;
    $gamerec{$g{id}} = \%gr;
    %g = DataGetNextRec();
  }
  %g = DataGetPastGameRec("postal=1 and eventid like '$eventName R1%'");
  while($g{id}){
    my(%gr);
    %gr = %g;
    $gr{done} = 1;
    $gamerec{$g{tempid}} = \%gr;
    %g = DataGetNextRec();
  }
  
  foreach $g (@g){
    ($w, $b, $ts, $tc, $why, $ply, $gid, $tgid) = ($g->{1}, $g->{2}, $g->{schts}, $g->{timecontrol}, $g->{why}, $g->{move}, $g->{gid}, $g->{tgid});
    ($wr, $br) = ($rating{$w}, $rating{$b});
    $wwin = ''; $bwin = '';
    if ($g->{won} eq '1'){ $wwin = '*'; }
    if ($g->{won} eq '2'){ $bwin = '*'; }
    if ($g->{won} eq 'd'){ $wwin = '='; $bwin = '='; }

    $x = $gamerec{$tgid};
    %gr = %$x;

    $gid = $gr{id};
    $ply = $gr{plycount};
    $turn = $gr{turn};
    $why = $gr{termination};
    $done = $gr{done};
    $win1 = ''; $win2 = '';
    if ($gr{result} eq 'w'){ $win1 = $w; }
    if ($gr{result} eq 'b'){ $win1 = $b; }
    if ($gr{result} eq 'd'){ $win1 = $w; $win2 = $b; }

# The following lines are needed anymore, since we read directly from the database instead of from a file.
#    chomp $l;
#    $cgid = 0;
#    $ply = ""; $win1 = ""; $win2 = "";
#    if ($roundName eq ""){
#      ($roundName) = ($l =~ m/^# *(.*)$/);
#    }
#    ($win1, $win2, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) (\w+) \[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\w) (\d+) (\d+)/);
#    if ($w eq ""){
#      ($win1, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) \[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\w) (\d+) (\d+)/);
#    }
#    if ($w eq ""){
#      ($win1, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) \[(\w+) (\d+) vs (\w+) (\d+)\]/);
#    }
#    if ($w eq ""){
#      ($w, $wr, $b, $br, $s, $ts, $cgid, $ply, $turn) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\d+) (\d+) (\w)/);
#    }
#    if ($w eq ""){
#      ($w, $wr, $b, $br, $s, $ts) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+)/);
#    }
#    if ($w eq ""){
#      ($w, $wr, $b, $br) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\]/);
#    }
#    if ($w eq ""){ next; }

    $wwin = ""; $bwin = "";
    if ($win1 eq $w){
      $wwin = "*";
    }
    if ($win1 eq $b){
      $bwin = "*";
    }
    if ($win2 ne ""){
      $wwin = "="; $bwin = "=";
    }

    if ($win1 eq ""){
      if ($turn eq 'w'){ $ply += 1; }
    }

    $scheduled = ($ts>time) ? &getDayHrMin($ts - $r{timezone}) : '';
    if ($done){
      $scheduled = ($ply ne "") ? "<a href='javascript:comPage($gid)'>$why $ply</a>" : $scheduled;
    }

    if ($win1 ne ""){
      $clickOnBoard = 1;
    }
    else{
      if ($ts>0){ $gameTimes = 1; }
    }

    $wRole = 'v';
    $bRole = 'v';
    if ($cgid > 0){
      $gid = $cgid;
      if ($r{username} eq $w){
        $wRole = "w";
      }
      if ($r{username} eq $b){
        $bRole = "b";
      }
    }
    $board = <<EOM;
<table background="/arimaa/graphics/BoardWithPiecesIcon.jpg" width=50 height=50 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td >
<a href="javascript:openGame('$gid','$wRole','w');" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
    <td >
<a href="javascript:openGame('$gid','$bRole','b');" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
  </tr>
</table>
EOM

    if ($cgid>0){
      $board =~ s/openGame/openCurrentGame/g;
    }

    if ($w eq $b){ 
      $gameRow = <<EOM;
<tr>
  <td align=right>
    <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>bye
  </td>
</tr>
EOM
      next;
    }

    $wturn = "";
    $bturn = "";
    if ($turn eq 'w'){ $wturn = "<font color=red><sup>$ply</sup></font> "; }
    if ($turn eq 'b'){ $bturn = " <font color=red><sup>$ply</sup></font>"; }
    $gameRow = <<EOM;
<tr>
  <td align=right>
    <nobr>$wwin $wturn<a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font></nobr>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>
    <nobr><a href="javascript:playerPage('$b')">$b</a>$bturn $bwin<br><font size=-1>$br</font></nobr>
  </td>
</tr>
EOM

    if ($why eq ""){
      push(@curGames, $gameRow);
    }
    else{
      push(@finGames, $gameRow);
    }

# store the games based on player name
    $pgrow{$w} .= "$gameRow";
    $pgrow{$b} .= "$gameRow";

# Keep a running total of the player scores
    if ($win1 && $win2){
#      $score{$win1} += 0.5;
#      $score{$win2} += 0.5;
      $points{$win1} += 60;
      $points{$win2} += 60;
    }
    elsif ($win1 ne ""){
      if ($win1 eq $w){ 
        $wins{$w} += 1; $loses{$b} += 1;
        $score{$w} += 1; 
        $score{$b} -= 1; 
        $points{$w} += 60;
        if (($why eq 'r') || ($why eq 't') || ($why eq 'f')){
          $points{$b} -= 60;
        }
        else{
          $points{$b} += ($ply>60)?60:$ply;
        }
      }
      else{
        $wins{$b} += 1; $loses{$w} += 1;
        $score{$b} += 1; 
        $score{$w} -= 1; 
        $points{$b} += 60;
        if (($why eq 'r') || ($why eq 't') || ($why eq 'f')){
          $points{$w} -= 60;
        }
        else{
          $points{$w} += ($ply>60)?60:$ply;
        }
      }
    }
    if ($score{$w} eq ""){ $score{$w} = 0; }
    if ($score{$b} eq ""){ $score{$b} = 0; }
    if ($points{$w} eq ""){ $points{$w} = 0; }
    if ($points{$b} eq ""){ $points{$b} = 0; }
    if ($wins{$w} eq ""){ $wins{$w} = 0; }
    if ($wins{$b} eq ""){ $wins{$b} = 0; }
    if ($loses{$w} eq ""){ $loses{$w} = 0; }
    if ($loses{$b} eq ""){ $loses{$b} = 0; }

# Keep a list of the player ratings
    if ($wr > 0){ $rating{$w} = $wr; }
    if ($br > 0){ $rating{$b} = $br; }

  }
  close FH;

# Compute the stanadings from the score
  while(($k, $v) = each(%score)){
    $standings = <<EOM;
<tr>
<td align=center>$wins{$k}</td>
<td align=center>$loses{$k}</td>
<td align=center>$v</td>
<td align=center>$points{$k}</td>
<td><a href="javascript:playerPage('$k')">$k</a></td>
<td align=right><font size=-1>$rating{$k}</font></td>
</tr>
EOM
#    push(@standings, sprintf("%05d %s", $v*2, $standings));
    push(@standings, sprintf("%05d %s", 10000+$v, $standings));
  }
  @standings = sort(@standings);
  @standings = reverse(@standings);
  grep { s/^\d+ //; } @standings;
  $standings = join('', @standings);

  if ($standings){
    $standings = <<EOM;
<td> </td>
<td valign=top>
  <table border=0>
<tr><td colspan=5 align=center><b>Standings</b></td></tr>
<tr>
  <td>Wins</td> <td>Loses</td> <td>Win-Lose</td> <td><a href="points.html">Points</a></td> <td>Player</td> <td>Rating</td>
</tr>
<tr><td colspan=5> </td></tr>
$standings
<tr><td colspan=5> </td></tr>
<tr><td colspan=5 align=center><font size=1>Ratings at start of tournament</td></tr>
  </table>
</td>
EOM
  }


  if ($clickOnBoard){
    $clickOnBoard = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<b>
<font size=-2>
Click on the board<br>to view the game
</font>
</b>
    </td>
  </tr>
EOM
  }



  if ($roundName eq ""){
    $roundName = "Round $r";
  }

  if ($gameTimes){
    $gameTimes = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<font size=-2>
Times are in $gmt
</font>
    </td>
  </tr>
EOM
  }


  $curGames = join("\n", @curGames);
  $finGames = join("\n", @finGames);


##########################
  while(($pn, $pgrow) = each(%pgrow)){
    $pnlc = lc($pn);
    push(@pname, $pnlc);
    $pnreal{$pnlc} = $pn;
  }
  @pname = sort(@pname);

  foreach $pnlc (@pname){
#  while(($pn, $pgrow) = each(%pgrow)){
    $pn = $pnreal{$pnlc};
    $pgrow = $pgrow{$pn};
    $pnames .= <<EOM;
<td align=center>$pn</td>
EOM
    $pgames .= <<EOM;
<td valign=top><table>$pgrow</table></td>
EOM
  }

  $pgtab = <<EOM;
<td>
<table border=1>
<tr> $pnames </tr>
<tr> $pgames </tr>
</table>
</td>
EOM

  if ($curGames){
    $curGames = <<EOM;
<td valign=top>
<table border=0>
  <tr><td></td>
    <td colspan=2 align=left>
<b>
Current Games
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $curGames
  $gameTimes
</table>
<td>
EOM
  }

  if ($finGames){
    $finGames = <<EOM;
<td valign=top>
<table border=0>
  <tr><td></td>
    <td colspan=2 align=left>
<b>
Finished Games
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $finGames
  $clickOnBoard
</table>
<td>
EOM
  }




  $watchGames .= <<EOM;
<td valign=top>
<table border=0>
  <tr><td></td>
    <td colspan=2 align=left>
<b>
$roundName
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $gameRows
  $clickOnBoard
  $gameTimes
</table>
<td>
EOM

  $func = <<EOM;
    <script language="JavaScript1.2">
<!--
function playerPage(u){
    open('/arimaa/gameroom/playerpage.cgi?u='+u,'','toolbar=no,width=650,height=450,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function comPage(g){
    open('/arimaa/gameroom/comments.cgi?gid='+g,'','');
    void('');
}

function openGame(id, role, side){
  if (parseInt(id) > 0){
    open('/arimaa/gameroom/opengamewin.cgi?gameid='+id+'&role='+role+'&side='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
  }
  else{
    if (parseInt(id) == 0){
      alert("Game was won by forfeit");
    }
    else{
      alert("To watch the game login to the Arimaa gameroom and use 'Current Games'");
    }
  }
  void('');
}

function openCurrentGame(id, role, side){
  if (parseInt(id) > 0){
    open('/arimaa/gameroom/opengamewin.cgi?gameid='+id+'&role='+role+'&side='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
  }
  else{
    alert("To watch the game login to the Arimaa gameroom and use 'Current Games'");
  }
  void('');
}

// -->
    </script>
EOM

}


print <<EOM;
<html>
  <head>
    <title>$eventFullName</title>
    <link rel="stylesheet" type="text/css" href="/arimaa/css/main.css">
  </head>
  <body bgcolor=#d8d8f8>
$func
    <center>
<p><font size=+2><b>$eventFullName</b></font>
<p>
    <table>
      <tr>
$standings
$pgtab
$xcurGames
$xfinGames
      </tr>
    <table>
    </center>
  </body>
</html>

EOM




